/* File:      prof_sbp.P
** Author(s): Kostis F, Sagonas, Jiyang Xu 
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1986, 1993-1998
** Copyright (C) ECRC, Germany, 1990
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** $Id: prof_sbp.P,v 1.6 1999/12/09 23:40:13 kifer Exp $
** 
*/


/***********
    ALL PREDICATES HERE ARE OBSOLETE!!!!!
***********/


/*======================================================================*/
/* prepare for compiler and type inference				*/
/*======================================================================*/

prepare :-
	obsolete('prepare/0 in module prof_sbp',
		 'use prepare/0 in module gensym'),
	conset(gennum_val, 300).	/* for gennum and gensym */
		/* big number to avoid conflict in internal variable */
		/* generated by gennum with read-in variable numbered */
		/* from 0 above */

/*======================================================================*/
/* The following predicates may be standard in some variation of Prolog,*/
/* may have different meanings.						*/
/*   Include here for compatibility.					*/
/*======================================================================*/


/*----conlength---------------------------------------------------------*/

conlength(Con, Length) :-
	obsolete('conlength/2 in module prof_sbp',
		 'use conlength/2 in module gensym'),
	conname(Con, Name), str_len(Name, Len), Length = Len.

/*----gennum------------------------------------------------------------*/

gennum(N) :-
	obsolete('gennum/1 in module prof_sbp',
		 'use gennum/1 in module gensym'),
	conget(gennum_val, O), N is O + 1, conset(gennum_val, N).

/*----gensym------------------------------------------------------------*/

gensym(R, C) :-
	obsolete('gensym/2 in module prof_sbp',
		 'use gensym/2 in module gensym'),
	gennum(N), atom_codes(R, N1), name(N, N2),
	append(N1, N2, N3), atom_codes(C, N3).

/*----copyterm----------------------------------------------------------*/
/* Get a copy of the Term, with a new set of variables.			*/

copyterm(Term, NewTerm) :-
	obsolete('copyterm/2 in module prof_sbp',
		 'use copy_term/2 in module basics'),
	copyterm(Term, NewTerm, _).

copyterm(Term, NewTerm, VarDict) :- var(Term), !,
	dict_lookup(Term, NewTerm, VarDict).
copyterm(Term, Term, _) :- atomic(Term), !.
copyterm(Term, NewTerm, VarDict) :- 
	functor(Term, Func, Arity),
	functor(NewTerm, Func, Arity),
	copyterm_args(Term, NewTerm, Arity, VarDict).

copyterm_args(_, _, 0, _) :- !.
copyterm_args(Term, NewTerm, N, VarDict) :-
	arg(N, Term, Arg),
	copyterm(Arg, NewArg, VarDict),
	arg(N, NewTerm, NewArg),
	N1 is N - 1,
	copyterm_args(Term, NewTerm, N1, VarDict).

conset(Con, Val) :- 
	obsolete('conset/2 in module prof_sbp',
		 'use conset/2 in module gensym'),
	conpsc(Con, Psc), psc_set_prop(Psc, Val).

conget(Con, Val) :- 
	obsolete('conget/2 in module prof_sbp',
		 'use conget/2 in module gensym'),
	conpsc(Con, Psc), psc_prop(Psc, Val0), Val = Val0.

coninc(Con) :-
	obsolete('coninc/2 in module prof_sbp',
		 'use coninc/2 in module gensym'),
	conpsc(Con, Psc), psc_prop(Psc, N),
	NewN is N+1, psc_set_prop(Psc, NewN).

/*======================================================================*/
/* counter routines. A counter is a unary term.				*/
/*======================================================================*/

newcounter(C) :-
	obsolete('newcounter/1 in module prof_sbp',
		 'use newcounter/1 in module gensym'),
	conpsc(C, Psc), psc_set_type(Psc, 8),
	arg(1, C, V), 
	( integer(V), V0 = V
	; V0 = 0
	),
	psc_set_prop(Psc, V0).

inccounter(C) :- 
	obsolete('inccounter/1 in module prof_sbp',
		 'use inccounter/1 in module gensym'),
	conpsc(C, Psc), psc_prop(Psc, V), 
	V1 is V + 1, psc_set_prop(Psc, V1).

getcounter(C) :-
	obsolete('getcounter/1 in module prof_sbp',
		 'use getcounter/1 in module gensym'),
	conpsc(C, Psc), psc_prop(Psc, V), arg(1, C, V).


write_int(Num) :- 
	obsolete('write_int/1 in module prof_sbp',
		 'use write_int/1 in module xsb_writ'),
	stat_flag(11, File),
	file_puttoken(File, 16, Num).

write_float(Num) :- 
	obsolete('write_float/1 in module prof_sbp',
		 'use write_float/1 in module xsb_writ'),
	stat_flag(11, File),
	file_puttoken(File, 17, Num).
